scala.sys.process

# BasicIO

#### object BasicIO extends AnyRef

This object contains factories for ProcessIO, which can be used to control the I/O of a Process when a ProcessBuilder is started with the `run` command.

It also contains some helper methods that can be used to in the creation of `ProcessIO`.

It is used by other classes in the package in the implementation of various features, but can also be used by client code.

Source
  BasicIO.scala

Linear Supertypes
AnyRef, Any
Ordering

1. Alphabetic
2. By inheritance

Inherited

1. Hide All
2. Show all

1. BasicIO
2. AnyRef
3. Any

Visibility

1. Public
2. All

### Value Members

1. #### final def !=(arg0: AnyRef): Boolean

   Definition Classes
     AnyRef

2. #### final def !=(arg0: Any): Boolean

   Test two objects for inequality.

   Test two objects for inequality.

   returns

     `true` if !(this == that), false otherwise.

   Definition Classes
     Any

3. #### final def ##(): Int

   Equivalent to `x.hashCode` except for boxed numeric types.

   Equivalent to `x.hashCode` except for boxed numeric types. For numerics, it returns a hash value which is consistent with value equality: if two value type instances compare as true, then ## will produce the same hash value for each of them.

   returns

     a hash value consistent with ==

   Definition Classes
     AnyRef → Any

4. #### final def ==(arg0: AnyRef): Boolean

   Definition Classes
     AnyRef

5. #### final def ==(arg0: Any): Boolean

   Test two objects for equality.

   Test two objects for equality.

   returns

     `true` if the receiver object is equivalent to the argument; `false` otherwise.

   Definition Classes
     Any

6. #### final val BufferSize: Int(8192)

   Size of the buffer used in all the functions that copy data

7. #### final val Newline: String

   Used to separate lines in the `processFully` function that takes `Appendable`.

8. #### def apply(withIn: Boolean, log: ProcessLogger): ProcessIO

   Creates a `ProcessIO` from a `ProcessLogger` .

   Creates a `ProcessIO` from a `ProcessLogger` . It can attach the process input to stdin.

   withIn

     True if the process input should be attached to stdin.

   log

     A `ProcessLogger` to receive all output, normal and error.

   returns

     A `ProcessIO` with the characteristics above.

9. #### def apply(withIn: Boolean, buffer: StringBuffer, log: Option[ProcessLogger]): ProcessIO

   Creates a `ProcessIO` that appends its output to a `StringBuffer`.

   Creates a `ProcessIO` that appends its output to a `StringBuffer`. It can attach the process input to stdin, and it will either send the error stream to stderr, or to a `ProcessLogger`.

   For example, the `ProcessIO` created by the function below will store the normal output on the buffer provided, and print all error on stderr. The input will be read from stdin.

       import scala.sys.process.{BasicIO, ProcessLogger}
       val printer = ProcessLogger(println(_))
       def appendToBuffer(b: StringBuffer) = BasicIO(true, b, Some(printer))

   withIn

     True if the process input should be attached to stdin.

   buffer

     A `StringBuffer` which will receive the process normal output.

   log

     An optional `ProcessLogger` to which the output should be sent. If `None`, output will be sent to stderr.

   returns

     A `ProcessIO` with the characteristics above.

10. #### def apply(withIn: Boolean, output: (String) ⇒ Unit, log: Option[ProcessLogger]): ProcessIO

    Creates a `ProcessIO` from a function `String => Unit`.

    Creates a `ProcessIO` from a function `String => Unit`. It can attach the process input to stdin, and it will either send the error stream to stderr, or to a `ProcessLogger`.

    For example, the `ProcessIO` created below will print all normal output while ignoring all error output. No input will be provided.

        import scala.sys.process.BasicIO
        val errToDevNull = BasicIO(false, println(_), None)

    withIn

      True if the process input should be attached to stdin.

    output

      A function that will be called with the process output.

    log

      An optional `ProcessLogger` to which the output should be sent. If `None`, output will be sent to stderr.

    returns

      A `ProcessIO` with the characteristics above.

11. #### final def asInstanceOf[T0]: T0

    Cast the receiver object to be of type `T0`.

    Cast the receiver object to be of type `T0`.

    Note that the success of a cast at runtime is modulo Scala's erasure semantics. Therefore the expression `1.asInstanceOf[String]` will throw a `ClassCastException` at runtime, while the expression `List(1).asInstanceOf[List[String]]` will not. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the requested type.

    returns

      the receiver object.

    Definition Classes
      Any
    Exceptions thrown
      ClassCastException

      if the receiver object is not an instance of the erasure of type `T0`.

12. #### def clone(): AnyRef

    Create a copy of the receiver object.

    Create a copy of the receiver object.

    The default implementation of the `clone` method is platform dependent.

    returns

      a copy of the receiver object.

    Attributes
      protected[lang]
    Definition Classes
      AnyRef
    Annotations
      @throws()
    Note

      not specified by SLS as a member of AnyRef

13. #### def close(c: Closeable): Unit

    Closes a `Closeable` without throwing an exception

14. #### def connectToIn(o: OutputStream): Unit

    Copy contents of stdin to the `OutputStream`.

15. #### final def eq(arg0: AnyRef): Boolean

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    The `eq` method implements an equivalence relation on non-null instances of `AnyRef`, and has three additional properties:

    - It is consistent: for any non-null instances `x` and `y` of type `AnyRef`, multiple invocations of `x.eq(y)` consistently returns `true` or consistently returns `false`.
    - For any non-null instance `x` of type `AnyRef`, `x.eq(null)` and `null.eq(x)` returns `false`.
    - `null.eq(null)` returns `true`.

    When overriding the `equals` or `hashCode` methods, it is important to ensure that their behavior is consistent with reference equality. Therefore, if two objects are references to each other (`o1 eq o2`), they should be equal to each other (`o1 == o2`) and they should hash to the same value (`o1.hashCode == o2.hashCode`).

    returns

      `true` if the argument is a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

16. #### def equals(arg0: Any): Boolean

    The equality method for reference types.

    The equality method for reference types. See equals in Any.

    returns

      `true` if the receiver object is equivalent to the argument; `false` otherwise.

    Definition Classes
      AnyRef → Any

17. #### def finalize(): Unit

    Called by the garbage collector on the receiver object when there are no more references to the object.

    Called by the garbage collector on the receiver object when there are no more references to the object.

    The details of when and if the `finalize` method is invoked, as well as the interaction between `finalize` and non-local returns and exceptions, are all platform dependent.

    Attributes
      protected[lang]
    Definition Classes
      AnyRef
    Annotations
      @throws()
    Note

      not specified by SLS as a member of AnyRef

18. #### final def getClass(): java.lang.Class[_]

    A representation that corresponds to the dynamic class of the receiver object.

    A representation that corresponds to the dynamic class of the receiver object.

    The nature of the representation is platform dependent.

    returns

      a representation that corresponds to the dynamic class of the receiver object.

    Definition Classes
      AnyRef → Any
    Note

      not specified by SLS as a member of AnyRef

19. #### def getErr(log: Option[ProcessLogger]): (InputStream) ⇒ Unit

    Returns a function `InputStream => Unit` given an optional `ProcessLogger`.

    Returns a function `InputStream => Unit` given an optional `ProcessLogger`. If no logger is passed, the function will send the output to stderr. This function can be used to create a ProcessIO.

    log

      An optional `ProcessLogger` to which the contents of the `InputStream` will be sent.

    returns

      A function `InputStream => Unit` (used by ProcessIO) which will send the data to either the provided `ProcessLogger` or, if `None`, to stderr.

20. #### def hashCode(): Int

    The hashCode method for reference types.

    The hashCode method for reference types. See hashCode in Any.

    returns

      the hash code value for this object.

    Definition Classes
      AnyRef → Any

21. #### def input(connect: Boolean): (OutputStream) ⇒ Unit

    Returns a function `OutputStream => Unit` that either reads the content from stdin or does nothing.

    Returns a function `OutputStream => Unit` that either reads the content from stdin or does nothing. This function can be used by ProcessIO.

22. #### final def isInstanceOf[T0]: Boolean

    Test whether the dynamic type of the receiver object is `T0`.

    Test whether the dynamic type of the receiver object is `T0`.

    Note that the result of the test is modulo Scala's erasure semantics. Therefore the expression `1.isInstanceOf[String]` will return `false`, while the expression `List(1).isInstanceOf[List[String]]` will return `true`. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the specified type.

    returns

      `true` if the receiver object is an instance of erasure of type `T0`; `false` otherwise.

    Definition Classes
      Any

23. #### final def ne(arg0: AnyRef): Boolean

    Equivalent to `!(this eq that)`.

    Equivalent to `!(this eq that)`.

    returns

      `true` if the argument is not a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

24. #### final def notify(): Unit

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

25. #### final def notifyAll(): Unit

    Wakes up all threads that are waiting on the receiver object's monitor.

    Wakes up all threads that are waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

26. #### def processFully(processLine: (String) ⇒ Unit): (InputStream) ⇒ Unit

    Returns a function `InputStream => Unit` that will call the passed function with all data read.

    Returns a function `InputStream => Unit` that will call the passed function with all data read. This function can be used to create a ProcessIO. The `processLine` function will be called with each line read, and `Newline` will be appended after each line.

    processLine

      A function that will be called with all data read from the stream.

    returns

      A function `InputStream => Unit` (used by ProcessIO which will call `processLine` with all data read from the stream.

27. #### def processFully(buffer: Appendable): (InputStream) ⇒ Unit

    Returns a function `InputStream => Unit` that appends all data read to the provided `Appendable`.

    Returns a function `InputStream => Unit` that appends all data read to the provided `Appendable`. This function can be used to create a ProcessIO. The buffer will be appended line by line.

    buffer

      An `Appendable` such as `StringBuilder` or `StringBuffer`.

    returns

      A function `InputStream => Unit` (used by ProcessIO which will append all data read from the stream to the buffer.

28. #### def processLinesFully(processLine: (String) ⇒ Unit)(readLine: () ⇒ String): Unit

    Calls `processLine` with the result of `readLine` until the latter returns `null`.

29. #### def standard(in: (OutputStream) ⇒ Unit): ProcessIO

    Retruns a `ProcessIO` connected to stdout, stderr and the provided `in`

30. #### def standard(connectInput: Boolean): ProcessIO

    Returns a `ProcessIO` connected to stdout and stderr, and, optionally, stdin.

31. #### final def synchronized[T0](arg0: ⇒ T0): T0

    Definition Classes
      AnyRef

32. #### def toStdErr: (InputStream) ⇒ Unit

    Send all the input from the stream to stderr, and closes the input stream afterwards.

33. #### def toStdOut: (InputStream) ⇒ Unit

    Send all the input from the stream to stdout, and closes the input stream afterwards.

34. #### def toString(): String

    Creates a String representation of this object.

    Creates a String representation of this object. The default representation is platform dependent. On the java platform it is the concatenation of the class name, "@", and the object's hashcode in hexadecimal.

    returns

      a String representation of the object.

    Definition Classes
      AnyRef → Any

35. #### def transferFully(in: InputStream, out: OutputStream): Unit

    Copy all input from the input stream to the output stream.

    Copy all input from the input stream to the output stream. Closes the input stream once it's all read.

36. #### final def wait(): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws()

37. #### final def wait(arg0: Long, arg1: Int): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws()

38. #### final def wait(arg0: Long): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws()

### Inherited from AnyRef

### Inherited from Any